package com.hotwj.platform.driverManagement.driverFileSign.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.driverManagement.driverFileSign.domain.HotDriverFileSign;
import com.hotwj.platform.driverManagement.driverFileSign.domain.bo.HotDriverFileSignBo;
import com.hotwj.platform.driverManagement.driverFileSign.domain.vo.HotDriverFileSignVo;
import com.hotwj.platform.driverManagement.driverFileSign.mapper.HotDriverFileSignMapper;
import com.hotwj.platform.driverManagement.driverFileSign.service.IHotDriverFileSignService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 驾驶员文件签订Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-22
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotDriverFileSignServiceImpl implements IHotDriverFileSignService {

    private final HotDriverFileSignMapper baseMapper;

    /**
     * 查询驾驶员文件签订
     *
     * @param id 主键
     * @return 驾驶员文件签订
     */
    @Override
    public HotDriverFileSignVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询驾驶员文件签订列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 驾驶员文件签订分页列表
     */
    @Override
    public TableDataInfo<HotDriverFileSignVo> queryPageList(HotDriverFileSignBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotDriverFileSign> lqw = buildQueryWrapper(bo);
        Page<HotDriverFileSignVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的驾驶员文件签订列表
     *
     * @param bo 查询条件
     * @return 驾驶员文件签订列表
     */
    @Override
    public List<HotDriverFileSignVo> queryList(HotDriverFileSignBo bo) {
        LambdaQueryWrapper<HotDriverFileSign> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotDriverFileSign> buildQueryWrapper(HotDriverFileSignBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotDriverFileSign> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotDriverFileSign::getId);
        lqw.eq(bo.getDriverId() != null, HotDriverFileSign::getDriverId, bo.getDriverId());
        lqw.like(StringUtils.isNotBlank(bo.getFileName()), HotDriverFileSign::getFileName, bo.getFileName());
        lqw.eq(StringUtils.isNotBlank(bo.getSignFileImgUrl()), HotDriverFileSign::getSignFileImgUrl, bo.getSignFileImgUrl());
        lqw.like(StringUtils.isNotBlank(bo.getHandlerName()), HotDriverFileSign::getHandlerName, bo.getHandlerName());
        lqw.eq(bo.getSignTime() != null, HotDriverFileSign::getSignTime, bo.getSignTime());
        lqw.eq(bo.getExpireTime() != null, HotDriverFileSign::getExpireTime, bo.getExpireTime());
        lqw.eq(bo.getIsArchived() != null, HotDriverFileSign::getIsArchived, bo.getIsArchived());
        lqw.eq(bo.getIsDeleted() != null, HotDriverFileSign::getIsDeleted, bo.getIsDeleted());
        lqw.eq(bo.getCompanyId() != null, HotDriverFileSign::getCompanyId, bo.getCompanyId());
        return lqw;
    }

    /**
     * 新增驾驶员文件签订
     *
     * @param bo 驾驶员文件签订
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotDriverFileSignBo bo) {
        HotDriverFileSign add = MapstructUtils.convert(bo, HotDriverFileSign.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改驾驶员文件签订
     *
     * @param bo 驾驶员文件签订
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotDriverFileSignBo bo) {
        HotDriverFileSign update = MapstructUtils.convert(bo, HotDriverFileSign.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotDriverFileSign entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除驾驶员文件签订信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
